RSASSAPSSparams (Bouncy Castle Library 1.85 API Specification)
Date: 2026-07-12

org.bouncycastle.asn1.pkcs

## Class RSASSAPSSparams

- java.lang.Object
- - org.bouncycastle.asn1.ASN1Object
  - - org.bouncycastle.asn1.pkcs.RSASSAPSSparams

- All Implemented Interfaces:
    ASN1Encodable, Encodable

      public class RSASSAPSSparams
      extends ASN1Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static AlgorithmIdentifier` | `DEFAULT_HASH_ALGORITHM`
    `static AlgorithmIdentifier` | `DEFAULT_MASK_GEN_FUNCTION`
    `static ASN1Integer` | `DEFAULT_SALT_LENGTH`
    `static ASN1Integer` | `DEFAULT_TRAILER_FIELD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RSASSAPSSparams()` The default version
    `RSASSAPSSparams(AlgorithmIdentifier hashAlgorithm, AlgorithmIdentifier maskGenAlgorithm, ASN1Integer saltLength, ASN1Integer trailerField)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `AlgorithmIdentifier` | `getHashAlgorithm()`
    `static RSASSAPSSparams` | `getInstance(java.lang.Object obj)`
    `AlgorithmIdentifier` | `getMaskGenAlgorithm()`
    `java.math.BigInteger` | `getSaltLength()`
    `java.math.BigInteger` | `getTrailerField()`
    `ASN1Primitive` | `toASN1Primitive()` RSASSA-PSS-params ::= SEQUENCE { hashAlgorithm [0] OAEP-PSSDigestAlgorithms DEFAULT sha1, maskGenAlgorithm [1] PKCS1MGFAlgorithms DEFAULT mgf1SHA1, saltLength [2] INTEGER DEFAULT 20, trailerField [3] TrailerField DEFAULT trailerFieldBC } OAEP-PSSDigestAlgorithms ALGORITHM-IDENTIFIER ::= { { OID id-sha1 PARAMETERS NULL }| { OID id-sha256 PARAMETERS NULL }| { OID id-sha384 PARAMETERS NULL }| { OID id-sha512 PARAMETERS NULL }, ... -- Allows for future expansion -- } PKCS1MGFAlgorithms ALGORITHM-IDENTIFIER ::= { { OID id-mgf1 PARAMETERS OAEP-PSSDigestAlgorithms }, ... -- Allows for future expansion -- } TrailerField ::= INTEGER { trailerFieldBC(1) }

    - ### Methods inherited from class org.bouncycastle.asn1.ASN1Object

      `encodeTo, encodeTo, equals, getEncoded, getEncoded, hasEncodedTagValue, hashCode`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_HASH_ALGORITHM

          public static final AlgorithmIdentifier DEFAULT_HASH_ALGORITHM

    - #### DEFAULT_MASK_GEN_FUNCTION

          public static final AlgorithmIdentifier DEFAULT_MASK_GEN_FUNCTION

    - #### DEFAULT_SALT_LENGTH

          public static final ASN1Integer DEFAULT_SALT_LENGTH

    - #### DEFAULT_TRAILER_FIELD

          public static final ASN1Integer DEFAULT_TRAILER_FIELD

  - ### Constructor Detail

    - #### RSASSAPSSparams

          public RSASSAPSSparams()

      The default version

    - #### RSASSAPSSparams

          public RSASSAPSSparams(AlgorithmIdentifier hashAlgorithm,
                                 AlgorithmIdentifier maskGenAlgorithm,
                                 ASN1Integer saltLength,
                                 ASN1Integer trailerField)

  - ### Method Detail

    - #### getInstance

          public static RSASSAPSSparams getInstance(java.lang.Object obj)

    - #### getHashAlgorithm

          public AlgorithmIdentifier getHashAlgorithm()

    - #### getMaskGenAlgorithm

          public AlgorithmIdentifier getMaskGenAlgorithm()

    - #### getSaltLength

          public java.math.BigInteger getSaltLength()

    - #### getTrailerField

          public java.math.BigInteger getTrailerField()

    - #### toASN1Primitive

          public ASN1Primitive toASN1Primitive()

           RSASSA-PSS-params ::= SEQUENCE {
             hashAlgorithm      [0] OAEP-PSSDigestAlgorithms  DEFAULT sha1,
              maskGenAlgorithm   [1] PKCS1MGFAlgorithms  DEFAULT mgf1SHA1,
              saltLength         [2] INTEGER  DEFAULT 20,
              trailerField       [3] TrailerField  DEFAULT trailerFieldBC
            }

           OAEP-PSSDigestAlgorithms    ALGORITHM-IDENTIFIER ::= {
              { OID id-sha1 PARAMETERS NULL   }|
              { OID id-sha256 PARAMETERS NULL }|
              { OID id-sha384 PARAMETERS NULL }|
              { OID id-sha512 PARAMETERS NULL },
              ...  -- Allows for future expansion --
           }

           PKCS1MGFAlgorithms    ALGORITHM-IDENTIFIER ::= {
             { OID id-mgf1 PARAMETERS OAEP-PSSDigestAlgorithms },
              ...  -- Allows for future expansion --
           }

           TrailerField ::= INTEGER { trailerFieldBC(1) }

      Specified by:
        `toASN1Primitive` in interface `ASN1Encodable`
      Specified by:
        `toASN1Primitive` in class `ASN1Object`
      Returns:
        the asn1 primitive representing the parameters.